//converts 2 bit BMP to 4 pixels/byte and outputs raw data and text file easily pasted into Propeller editor (image is horizontally mirrored in output)
//by Pat Daderko (dogp@comcast.net)

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>

int main()     
{
	ifstream infile;
	ofstream outfile;
	ofstream txtfile;
	char in;
	int input;
	unsigned char output;
	int length;
	int temp;

	infile.open("display.bmp",fstream::binary|fstream::ate);
	outfile.open("display.out",fstream::binary);

	length = ((infile.tellg()-0x3E)/4);//number of WORDs
	infile.seekg(0x3E); //go to beginning of BMP data

	while (length > 0)
	{
		infile >> in;
		input = (in << 24);
		infile >> in;
		input |= (in << 16);
		infile >> in;
		input |= (in << 8);
		infile >> in;
		input |= in;

		output = ((input>>18) & 0xff);
		output |= ((input>>12) & 0xff);
		output |= ((input>>6) & 0xff);
		output |= (input & 0xff);

		length--;
		outfile.seekp(length);
		outfile << output;
	}
	infile.close();
	outfile.close();

	infile.open("display.out",fstream::binary);
	txtfile.open("display.txt");
	while (1)
	{
		temp = infile.get();
		if (infile.eof())
			break;
		txtfile << hex << "$" << temp << ",";
	}

	txtfile.seekp(txtfile.tellp()-1); //get rid of trailing ','
	txtfile << endl;

	infile.close();
	txtfile.close();
	
	return 0;
}     
